# POST /customer — Create Customer

> Product: **Pabbly Subscription Billing** (v1)
> Base URL: `https://payments.pabbly.com/api/v1`
> Auth: Basic via `Authorization` header
> Canonical: `/subscription-billing/customers/create-customer`

Fire the link with POST request and fill the following details in from data. If the response status is success then a unique customer Id will be generated for that customer. Attributes ::

**Body parameters:**

| Name | Type | Required | Description |
|------|------|----------|-------------|
| first_name | string | Yes | First Name of your customer |
| last_name | string | Yes | Last Name of your customer. |
| email_id | string | Yes | Email address of your customer. |
| company_name | string | No |  |
| website | string | No |  |
| phone | string | No |  |
| billing_address | object | No |  |
|   ↳ attention | string | No |  |
|   ↳ street1 | string | No |  |
|   ↳ street2 | string | No |  |
|   ↳ city | string | No |  |
|   ↳ state | string | No |  |
|   ↳ zip_code | string | No |  |
|   ↳ country | string | No |  |
| shipping_address | object | No |  |
|   ↳ attention | string | No |  |
|   ↳ street1 | string | No |  |
|   ↳ street2 | string | No |  |
|   ↳ city | string | No |  |
|   ↳ state | string | No |  |
|   ↳ zip_code | string | No |  |
|   ↳ country | string | No |  |
| is_affiliate | boolean | No | To create this customer as a Affiliate, It can be boolean value true or false |
| Basic Details | string | No | Company name, Website, Phone number, Billing address, Shipping address are the optional fields |

**Example request body:**

```json
{
    "first_name" : "John", 
    "last_name" : "Doe", 
    "email_id" : "johndoe@teleworm.us",
	"company_name": "Omni Source",
	"website": "anstudios.com",
	"phone": "406-775-3868",
    "billing_address" : {
    	"attention" : "Mr. Lance Crews", 
        "street1" : "936 Tibbs Avenue", 
        "street2" : "Jenna Lane",
        "city" : "Ekalaka", 
        "state" : "MT", 
        "zip_code" : "59324", 
        "country" : "US"
     
    },
    "shipping_address" : {
       "attention" : "Mr. Lance Crews", 
        "street1" : "936 Tibbs Avenue", 
        "street2" : "Jenna Lane",
        "city" : "Ekalaka", 
        "state" : "MT", 
        "zip_code" : "59324", 
        "country" : "US"
    },
    "is_affiliate": true
}
```

**Response (200)** — Create Customer:

```json
{
    "status": "success",
    "message": "Customer Created",
    "data": {
        "company_name": "Omni Source",
        "website": "anstudios.com",
        "phone": "406-775-3868",
        "billing_address": {
            "attention": "Mr. Lance Crews",
            "street1": "936 Tibbs Avenue",
            "street2": "Jenna Lane",
            "city": "Ekalaka",
            "state": "MT",
            "zip_code": "59324",
            "country": "US"
        },
        "shipping_address": {
            "attention": "Mr. Lance Crews",
            "street1": "936 Tibbs Avenue",
            "street2": "Jenna Lane",
            "city": "Ekalaka",
            "state": "MT",
            "zip_code": "59324",
            "country": "US"
        },
        "createdAt": "2020-01-09T06:25:25.498Z",
        "updatedAt": "2020-01-09T06:25:25.498Z",
        "id": "5e16c7556d73c34665ade042",
        "first_name": "John",
        "last_name": "Doe",
        "email_id": "johndoe@teleworm.us"
    }
}
```

**Code examples:**

_cURL_

```curl
curl -X POST https://payments.pabbly.com/api/v1/customer \
  -u {{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}} \
  -H "Content-Type: application/json" \
  -d '{
    "first_name": "John",
    "last_name": "Doe",
    "email_id": "johndoe@teleworm.us",
    "company_name": "Omni Source",
    "website": "anstudios.com",
    "phone": "406-775-3868",
    "billing_address": {
      "attention": "Mr. Lance Crews",
      "street1": "936 Tibbs Avenue",
      "street2": "Jenna Lane",
      "city": "Ekalaka",
      "state": "MT",
      "zip_code": "59324",
      "country": "US"
    },
    "shipping_address": {
      "attention": "Mr. Lance Crews",
      "street1": "936 Tibbs Avenue",
      "street2": "Jenna Lane",
      "city": "Ekalaka",
      "state": "MT",
      "zip_code": "59324",
      "country": "US"
    },
    "is_affiliate": true
  }'
```

_Ruby_

```ruby
require 'net/http'
require 'json'

uri = URI('https://payments.pabbly.com/api/v1/customer')
request = Net::HTTP::Post.new(uri)
request.basic_auth '{{YOUR_API_KEY}}', '{{YOUR_SECRET_KEY}}'
request['Content-Type'] = 'application/json'
request.body = "{\"first_name\":\"John\",\"last_name\":\"Doe\",\"email_id\":\"johndoe@teleworm.us\",\"company_name\":\"Omni Source\",\"website\":\"anstudios.com\",\"phone\":\"406-775-3868\",\"billing_address\":{\"attention\":\"Mr. Lance Crews\",\"street1\":\"936 Tibbs Avenue\",\"street2\":\"Jenna Lane\",\"city\":\"Ekalaka\",\"state\":\"MT\",\"zip_code\":\"59324\",\"country\":\"US\"},\"shipping_address\":{\"attention\":\"Mr. Lance Crews\",\"street1\":\"936 Tibbs Avenue\",\"street2\":\"Jenna Lane\",\"city\":\"Ekalaka\",\"state\":\"MT\",\"zip_code\":\"59324\",\"country\":\"US\"},\"is_affiliate\":true}"

response = Net::HTTP.start(uri.hostname, uri.port, use_ssl: uri.scheme == 'https') do |http|
  http.request(request)
end

data = JSON.parse(response.body)
```

_Python_

```python
import requests
from requests.auth import HTTPBasicAuth

response = requests.post(
    'https://payments.pabbly.com/api/v1/customer',
    auth=HTTPBasicAuth('{{YOUR_API_KEY}}', '{{YOUR_SECRET_KEY}}'),
    json={
    'first_name': 'John',
    'last_name': 'Doe',
    'email_id': 'johndoe@teleworm.us',
    'company_name': 'Omni Source',
    'website': 'anstudios.com',
    'phone': '406-775-3868',
    'billing_address': {
        'attention': 'Mr. Lance Crews',
        'street1': '936 Tibbs Avenue',
        'street2': 'Jenna Lane',
        'city': 'Ekalaka',
        'state': 'MT',
        'zip_code': '59324',
        'country': 'US'
    },
    'shipping_address': {
        'attention': 'Mr. Lance Crews',
        'street1': '936 Tibbs Avenue',
        'street2': 'Jenna Lane',
        'city': 'Ekalaka',
        'state': 'MT',
        'zip_code': '59324',
        'country': 'US'
    },
    'is_affiliate': True
},
)

data = response.json()
```

_PHP_

```php
<?php
$ch = curl_init('https://payments.pabbly.com/api/v1/customer');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'POST');
curl_setopt($ch, CURLOPT_USERPWD, '{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}');
curl_setopt($ch, CURLOPT_HTTPHEADER, ['Content-Type: application/json']);
curl_setopt($ch, CURLOPT_POSTFIELDS, '{"first_name":"John","last_name":"Doe","email_id":"johndoe@teleworm.us","company_name":"Omni Source","website":"anstudios.com","phone":"406-775-3868","billing_address":{"attention":"Mr. Lance Crews","street1":"936 Tibbs Avenue","street2":"Jenna Lane","city":"Ekalaka","state":"MT","zip_code":"59324","country":"US"},"shipping_address":{"attention":"Mr. Lance Crews","street1":"936 Tibbs Avenue","street2":"Jenna Lane","city":"Ekalaka","state":"MT","zip_code":"59324","country":"US"},"is_affiliate":true}');

$response = curl_exec($ch);
curl_close($ch);
$data = json_decode($response, true);
```

_Java_

```java
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.util.Base64;

String credentials = Base64.getEncoder().encodeToString("{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}".getBytes());

HttpClient client = HttpClient.newHttpClient();
HttpRequest.Builder builder = HttpRequest.newBuilder()
    .uri(URI.create("https://payments.pabbly.com/api/v1/customer"))
    .header("Authorization", "Basic " + credentials)
    .header("Content-Type", "application/json")
    .method("POST", HttpRequest.BodyPublishers.ofString("{\"first_name\":\"John\",\"last_name\":\"Doe\",\"email_id\":\"johndoe@teleworm.us\",\"company_name\":\"Omni Source\",\"website\":\"anstudios.com\",\"phone\":\"406-775-3868\",\"billing_address\":{\"attention\":\"Mr. Lance Crews\",\"street1\":\"936 Tibbs Avenue\",\"street2\":\"Jenna Lane\",\"city\":\"Ekalaka\",\"state\":\"MT\",\"zip_code\":\"59324\",\"country\":\"US\"},\"shipping_address\":{\"attention\":\"Mr. Lance Crews\",\"street1\":\"936 Tibbs Avenue\",\"street2\":\"Jenna Lane\",\"city\":\"Ekalaka\",\"state\":\"MT\",\"zip_code\":\"59324\",\"country\":\"US\"},\"is_affiliate\":true}"));

HttpRequest request = builder.build();
HttpResponse<String> response = client.send(request, HttpResponse.BodyHandlers.ofString());
System.out.println(response.body());
```

_Node.js_

```node
const credentials = Buffer.from('{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}').toString('base64');

const response = await fetch('https://payments.pabbly.com/api/v1/customer', {
  method: 'POST',
  headers: {
    'Authorization': `Basic ${credentials}`,
    'Content-Type': 'application/json',
  },
  body: JSON.stringify({
    "first_name": "John",
    "last_name": "Doe",
    "email_id": "johndoe@teleworm.us",
    "company_name": "Omni Source",
    "website": "anstudios.com",
    "phone": "406-775-3868",
    "billing_address": {
      "attention": "Mr. Lance Crews",
      "street1": "936 Tibbs Avenue",
      "street2": "Jenna Lane",
      "city": "Ekalaka",
      "state": "MT",
      "zip_code": "59324",
      "country": "US"
    },
    "shipping_address": {
      "attention": "Mr. Lance Crews",
      "street1": "936 Tibbs Avenue",
      "street2": "Jenna Lane",
      "city": "Ekalaka",
      "state": "MT",
      "zip_code": "59324",
      "country": "US"
    },
    "is_affiliate": true
  }),
});

const data = await response.json();
```

_Go_

```go
package main

import (
    "fmt"
    "io"
    "net/http"
    "strings"
)

func main() {
    payload := strings.NewReader("{\"first_name\":\"John\",\"last_name\":\"Doe\",\"email_id\":\"johndoe@teleworm.us\",\"company_name\":\"Omni Source\",\"website\":\"anstudios.com\",\"phone\":\"406-775-3868\",\"billing_address\":{\"attention\":\"Mr. Lance Crews\",\"street1\":\"936 Tibbs Avenue\",\"street2\":\"Jenna Lane\",\"city\":\"Ekalaka\",\"state\":\"MT\",\"zip_code\":\"59324\",\"country\":\"US\"},\"shipping_address\":{\"attention\":\"Mr. Lance Crews\",\"street1\":\"936 Tibbs Avenue\",\"street2\":\"Jenna Lane\",\"city\":\"Ekalaka\",\"state\":\"MT\",\"zip_code\":\"59324\",\"country\":\"US\"},\"is_affiliate\":true}")
    req, _ := http.NewRequest("POST", "https://payments.pabbly.com/api/v1/customer", payload)
    req.Header.Set("Content-Type", "application/json")
    req.SetBasicAuth("{{YOUR_API_KEY}}", "{{YOUR_SECRET_KEY}}")

    res, _ := http.DefaultClient.Do(req)
    defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)
    fmt.Println(string(body))
}
```

_.NET_

```dotnet
using System.Net.Http;
using System.Net.Http.Headers;
using System.Text;
using System.Threading.Tasks;

var credentials = Convert.ToBase64String(Encoding.ASCII.GetBytes("{{YOUR_API_KEY}}:{{YOUR_SECRET_KEY}}"));

var client = new HttpClient();
var request = new HttpRequestMessage(HttpMethod.Post, "https://payments.pabbly.com/api/v1/customer");
request.Headers.TryAddWithoutValidation("Authorization", $"Basic {credentials}");
request.Content = new StringContent("{\"first_name\":\"John\",\"last_name\":\"Doe\",\"email_id\":\"johndoe@teleworm.us\",\"company_name\":\"Omni Source\",\"website\":\"anstudios.com\",\"phone\":\"406-775-3868\",\"billing_address\":{\"attention\":\"Mr. Lance Crews\",\"street1\":\"936 Tibbs Avenue\",\"street2\":\"Jenna Lane\",\"city\":\"Ekalaka\",\"state\":\"MT\",\"zip_code\":\"59324\",\"country\":\"US\"},\"shipping_address\":{\"attention\":\"Mr. Lance Crews\",\"street1\":\"936 Tibbs Avenue\",\"street2\":\"Jenna Lane\",\"city\":\"Ekalaka\",\"state\":\"MT\",\"zip_code\":\"59324\",\"country\":\"US\"},\"is_affiliate\":true}");
request.Content.Headers.ContentType = new MediaTypeHeaderValue("application/json");

var response = await client.SendAsync(request);
var data = await response.Content.ReadAsStringAsync();
Console.WriteLine(data);
```

---

**Other endpoints in Customers:**

- [GET /customer/{{customer_id}} — Get Single Customer via Customer ID](/subscription-billing/customers/get-single-customer-via-customer-id)
- [GET /customer/ — Get Single Customer via Customer Email](/subscription-billing/customers/get-single-customer-via-customer-email)
- [GET /customer/purchase-info/{{customer_id}} — Get Customer Purchase Information](/subscription-billing/customers/get-customer-purchase-information)
- [GET /customers — List All Customers](/subscription-billing/customers/list-all-customers)
- [PUT /customer/{{customer_id}} — Update Customer Detail](/subscription-billing/customers/update-customer-detail)
- [POST /subscription — Create Customer With Subscription](/subscription-billing/customers/create-customer-with-subscription)
- [DELETE /customers/{{customer_id}} — Delete Customer](/subscription-billing/customers/delete-customer)

